#include <iostream>

using namespace std;

const int MAXn = 30005;

void solve()
{
    int pozicija1=0,pozicija2=0;
    int n;
    cin >> n;
    int a[MAXn], b[MAXn];
    for(int i=0; i<n; i++){
        cin >> a[i];
        if(a[i] != 0){
            if(a[i]<0)
                pozicija1++;
            pozicija1 += i;
        }   
    }
    for(int i=0; i<n; i++){
        cin >> b[i];
        if(b[i] != 0){
            if(b[i]<0)
                pozicija2++;
            pozicija2 += i;
        }
    }
    if(pozicija1%2 == pozicija1%2)
        cout << "DA\n";
    else
        cout << "NE\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}